<?php

use think\migration\Migrator;

class CreateSysMenu extends Migrator
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $table = $this->table('sys_menu', ['engine' => 'InnoDB', 'comment' => '系统菜单表']);
        $table->addColumn('pid', 'integer', ['null' => false, 'default' => 0, 'comment' => '父级ID'])
            ->addColumn('title', 'string', ['limit' => 64, 'null' => false, 'comment' => '菜单标题'])
            ->addColumn('name', 'string', ['limit' => 64, 'null' => false, 'comment' => '菜单名称'])
            ->addColumn('path', 'string', ['limit' => 128, 'null' => false, 'comment' => '菜单path'])
            ->addColumn('icon', 'string', ['limit' => 64, 'null' => true, 'comment' => '菜单图标'])
            ->addColumn('redirect', 'string', ['limit' => 128, 'null' => true, 'comment' => '菜单重定向'])
            ->addColumn('component', 'string', ['limit' => 128, 'null' => true, 'comment' => '菜单组件'])
            ->addColumn('hidden', 'boolean', ['null' => false, 'default' => 0, 'comment' => '是否隐藏菜单:1为是, 0为否'])
            ->addColumn('actived', 'boolean', ['null' => false, 'default' => 0, 'comment' => '是否为选中状态:1为是, 0为否'])
            ->addColumn('keep_alive', 'boolean', ['null' => false, 'default' => 0, 'comment' => '是否缓存:1为是, 0为否'])
            ->addColumn('sort', 'integer', ['null' => false, 'default' => 0, 'comment' => '菜单排序'])
            ->addColumn('status', 'boolean', ['null' => false, 'default' => 1, 'comment' => '-1为禁用, 1为启用'])
            ->addColumn('created_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP', 'comment' => '创建时间'])
            ->addColumn('updated_at', 'timestamp', ['null' => false, 'default' => 'CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP', 'comment' => '更新时间'])
            ->addColumn('deleted_at', 'timestamp', ['null' => true, 'comment' => '删除时间'])
            ->addIndex(['name'], ['unique' => true, 'name' => 'idx_unique_name'])
            ->create();
    }
}
